#include "Max7219.h"

//Max7129 Zeichentabelle
const uint8_t chars[] = {126,48,109,121,51,91,95,112,127,123};

uint8_t  black_digit = 9;

void Load_Low(void)
{
  PORTB &= ~(1 << PB2);
}

void Load_High(void)
{
  PORTB |= (1 << PB2);
}

void SPIMasterInit(void)
{
    DDRB = (1<<PB2)|(1<<PB3)|(1<<PB5);      // set PB2(SS), PB3 (MOSI) and PB5 (SCK) output, all others input
    SPCR = (1<<SPE)|(1<<MSTR);           // enable SPI, Master, set clock rate fck/4
    PORTB |= (1 << PB7)|(1 << PB2);
}

void transmit(unsigned char addr, char data) 
{
    Load_Low();
    SPDR = addr;                      // Start transmission
    while(!(SPSR & (1<<SPIF)));       // Wait for transmission complete

    asm volatile("nop");

    SPDR = data;                      // Start transmission
    while(!(SPSR & (1<<SPIF)));       // Wait for transmission complete
    Load_High();
}

void SetMode(unsigned mode)
{
    transmit(0x0C,mode); 
}
void SetDecodeMode(uint8_t mode)
{
    transmit(0x09,mode);    //0x00 no decode / 0xFF all decode
}
void SetScanLimit(uint8_t mode)
{
    transmit(0x0B,mode);
}

void SetIntensity(uint8_t mode)
{
    transmit(0x0A,mode);       
}

void DisplayTest(unsigned mode)
{
    transmit(0x0F,mode); 
}

uint8_t code[] = {0,4,6,2,1,5,7,3};

void SetDigit(uint8_t digit, uint8_t data)
{
    if(digit > 9)
    {
        SetAll(0);
        transmit(code[0]+1,79);
        transmit(code[1]+1,5);
        transmit(code[2]+1,5);  
        while(1)
        {
            
             
        }   
    }
    if(digit != black_digit)
        transmit(code[digit]+1,data);
}

void SetAll(uint8_t data)
{
    for(uint8_t i = 1; i!=9;i++)
            transmit(i,data);   
}

void Show2DigitsDots(uint8_t number, uint8_t start_digit, uint8_t dots)
{
        SetDigit( start_digit, chars[number / 10] + ((dots & 1) ? 128 : 0 )); 
        SetDigit( start_digit + 1, chars[number % 10] + ((dots & 2) ? 128 : 0) );  
}

void Show2Digits(uint8_t number, uint8_t start_digit)
{
    Show2DigitsDots(number, start_digit, 0);   
}

void SetBlackDigit(uint8_t digit)
{
    black_digit = digit;
}
